#include "defs.h"
#include "Colors.h"
#include "my_sockets.h"

#define	MEM_SYS_LEVELS		3
#define	MY_CANVAS_HEIGHT	200
#define	MY_CANVAS_WIDTH		100
#define	CANVAS_PER_SYSTEM	5
#define	AT_MORE			5
	
int		ZOOM[AT_MORE][CANVAS_PER_SYSTEM];
int		max[AT_MORE][CANVAS_PER_SYSTEM];
int		HOW_MANY=0;
int		PLAY_BY_STEP=0;
int		LINE_NO, WHICH_WINDOW;
int		EXEC_INTERF_START_OK = 0;
int		EXECUTION_HAS_STOPED = 0;

Cms			total_cms;
Frame			Pframe,Slider_frame;
Canvas			Pcanvas[25];
Panel_item		slider_rate, Conter, Steper, Stoper;
int			Count_x2[AT_MORE];

GC			Pgc[25];
XGCValues		Pgc_val;
unsigned long		*Pwin_colors[25];
XID			Pxid[25];
Display			*PDisplay;
XFontStruct		*PFont;

Notify_value		Show_Simultaneous_execution_traces();

void 			par_repaint_proc();
void			adjust_Slider_frame_speed();
void			quit_Slider_frame();
void			Stop_call(), Continue_call();

int			ret_system_canvas_begin();
int			By_Step_Procedure();

extern Panel_item 	Parallel_Exec;
extern Panel_item 	StartR;

extern  int     	s_id;
extern	int		CONNECTION_OK;
extern	int		current_system;
extern	int		PLAY_WITH_SOURCE_CODE;
extern	int		READ_COMMANDS_FROM_FILE;
extern	void	show_final_results();

int	ddtb_total_misses[AT_MORE][5],idtb_total_misses[AT_MORE][5],dcache_total_misses[AT_MORE][5],
	icache_total_misses[AT_MORE][5], sec_level_cache_total_misses[AT_MORE][5]; 

int	ddtb_total_ref[AT_MORE][5],idtb_total_ref[AT_MORE][5],dcache_total_ref[AT_MORE][5], icache_total_ref[AT_MORE][5], sec_level_cache_total_ref[AT_MORE][5]; 
Msg_simultaneous	Update_Simultaneous_Interface;

FILE			*ffp[5];

struct  timeval     tp, tp_final;
struct  timezone    tzp, tzp_final;


void
ExecSimultWithDiffParams()
{
	int		x, y, i, j, k;
	int		N;
	int		width, height;
	Panel		Slider_panel;
	static char     stipple_bits[] = {0xAA, 0xAA, 0x55, 0x55};

	EXEC_INTERF_START_OK = 1;

	HOW_MANY++;
/*  fprintf(stderr,"HOW_MANY = %d \n",HOW_MANY);  */

	width = HOW_MANY*2*MY_CANVAS_WIDTH + 35*HOW_MANY;
	height = MEM_SYS_LEVELS*MY_CANVAS_HEIGHT + MEM_SYS_LEVELS*30;

	Pframe = (Frame)xv_create(NULL,FRAME,
			XV_WIDTH,		width,
			XV_HEIGHT,		height,
		NULL);

	xv_set(Pframe, FRAME_LABEL, "Simultaneus Execution", NULL);
	xv_set(Pframe, XV_X, 0, XV_Y, 0, NULL);

	PDisplay = (Display *)xv_get(Pframe,XV_DISPLAY);
	if (!(PFont = XLoadQueryFont(PDisplay,"fixed")))
	{
		puts("cannot load fixed font");
		exit(1);
	}

	x = 20;
	y = 30;
	N = HOW_MANY*5;
	k = 0;
/*  fprintf(stderr,"N is %d \n",N); */
	for (i = 0; i < HOW_MANY; i++)
	{
		int	ex_x,ex_y;

		ex_x = x;
		ex_y = y;
		for (j = 0; j < 5; j++)
		{
			Pcanvas[k] = (Canvas)xv_create(Pframe,CANVAS,
				CANVAS_X_PAINT_WINDOW,  TRUE,
				CANVAS_REPAINT_PROC,    par_repaint_proc,
				WIN_CMS,		total_cms,
				CANVAS_AUTO_SHRINK,	FALSE,
				CANVAS_AUTO_EXPAND,	FALSE,
				XV_WIDTH,		MY_CANVAS_WIDTH,
				XV_HEIGHT,		MY_CANVAS_HEIGHT,
				XV_X,			x,
				XV_Y,			y,
			NULL);
			xv_set(Pcanvas[k],WIN_FOREGROUND_COLOR,	all_cms_colors[3],NULL);
			k++;

			if (j == 0 | j == 2)
				x+= MY_CANVAS_WIDTH + 10;
			if (j == 1 | j == 3)
			{
				x = ex_x;
				y+=MY_CANVAS_HEIGHT + 20;
				if (j == 3)
					x+=MY_CANVAS_WIDTH/2 + 20;
			}
		}
		x = ex_x + 2*MY_CANVAS_WIDTH + 20;
		y = ex_y;
	}

	N = HOW_MANY*5;
	for (i = 0; i < N; i++)
	{
		Pxid[i] = (XID)xv_get(canvas_paint_window(Pcanvas[i]),XV_XID);
		Pgc_val.font = PFont->fid;
		Pgc_val.stipple = XCreateBitmapFromData(PDisplay,Pxid[i],stipple_bits,16,2);

		Pgc[i] = XCreateGC(PDisplay,Pxid[i],GCFont | GCStipple, &Pgc_val);

		Pwin_colors[i] = (unsigned long *)xv_get(Pcanvas[i],WIN_X_COLOR_INDICES);
	}

	Slider_frame = (Frame)xv_create(NULL, FRAME,
			FRAME_LABEL,    "Simultaneous Execution Representation - RATE:",
			XV_WIDTH,	300,
			XV_HEIGHT,	80,
		NULL);

	Slider_panel = (Panel)xv_create(Slider_frame, PANEL, NULL);

	(Panel_item)xv_create(Slider_panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Dismiss",
			PANEL_NOTIFY_PROC,	quit_Slider_frame,
		NULL);

	Stoper = (Panel_item)xv_create(Slider_panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Stop",
			PANEL_NOTIFY_PROC,	Stop_call,
		NULL);

	Conter = (Panel_item)xv_create(Slider_panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Continue",
			PANEL_NOTIFY_PROC,	Continue_call,
		NULL);

	Steper = (Panel_item)xv_create(Slider_panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Step",
			PANEL_NOTIFY_PROC,	By_Step_Procedure,
		NULL);

	{
		int k;

		for (k = 0; k < 5; k++)
		{
			char	name[25];
				
			sprintf(name,"/tmp/k%d",k);
			ffp[k] = fopen(name,"w");
		}
	}
	
	window_fit(Slider_frame);
	xv_main_loop(Pframe);
	xv_main_loop(Slider_frame);
}

void
Stop_call()
{
	if (!EXECUTION_HAS_STOPED)
		notify_set_itimer_func(Slider_frame , NULL , ITIMER_REAL , NULL , NULL);
	else
		xv_set(Stoper, PANEL_INACTIVE, TRUE, NULL);
}

void Continue_call() {
    static int first_call = 1;
    int tmptmp;

    if(first_call){
      tmptmp = sleep(2);
      first_call = 0;
    }
    adjust_Slider_frame_speed(1);

	if (!EXECUTION_HAS_STOPED)
	{
		CONNECTION_OK = 1;
		By_Step_Procedure();
		notify_set_itimer_func(Slider_frame , NULL , ITIMER_REAL , NULL , NULL);
		adjust_Slider_frame_speed(1);
	}
	else
		xv_set(Conter, PANEL_INACTIVE, TRUE, NULL);
}

void
par_repaint_proc(canvas, pw, dpy, xwin, xrects)
Canvas		canvas;
Xv_Window	pw;
Display		*dpy;
Window		xwin;
Xv_xrectlist	*xrects;
{
	return;
}

void
init_total_cms()
{
	total_cms = (Cms)xv_create(NULL, CMS,
			CMS_SIZE,	64,
			CMS_TYPE,	XV_STATIC_CMS,
			CMS_COLORS,	all_cms_colors,
			CMS_CONTROL_CMS,TRUE,
		NULL);
}

struct itimerval	S_timer;

void adjust_Slider_frame_speed(int value){
        S_timer.it_value.tv_usec = 20;
        S_timer.it_interval.tv_usec = (value + 20) * 1000;

        notify_set_itimer_func(Slider_frame,Show_Simultaneous_execution_traces,ITIMER_REAL,&S_timer,NULL);
}

/**** danalis code START ****/

int LineNumber, i4line = 0, i4buf, DataAvailable = 1, fifofd;
int nchars, SourceCodeActive;
char FileName[256], OldFileName[256], line[256], fifobuf[256];
extern int SourceCodeActive;

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

int nbread(fd, buf, size)
int fd, size;
char *buf;
{
  int nchars;
  nchars = read(fd, buf, size);

  if( !nchars ){    /* If EOF */
    return 0;
  }
  if( nchars == -1){/* If possible error */
    if(errno == EAGAIN){
      return -1;        /*If POSIX O_NONBLOCK is set and no data are available*/
    }
    else{
      if(errno == EWOULDBLOCK){
        return -1;      /*If BSD O_NDELAY is set and no data are available ****/
      }
      else{             /* If really an error cleanup and exit ****************/
        return -2;
      }
    }
  }
  return nchars;      /* If everything is fine */
}

/**** danalis code END ****/

Notify_value Show_Simultaneous_execution_traces(){

  int how_many, krata = 0;
  static int g_counter = 0, first_time = 0;


  if (!first_time){
    first_time = 1;
    gettimeofday(&tp, &tzp);

    /**** danalis code START ****/

    /* We assume that cashesim (that creates the fifo) is already running */

    fifofd = open("/tmp/.fifo", O_RDONLY|O_NDELAY);

    /*
       We use O_NDELAY because read is in a faster loop than write 
       (which is in cachesim) and we don't want to stall waitting
       for the data. Using No Delay, we check if there is anything
       in the pipe and if so, we read it
    */

    /**** danalis code END ****/

  }

  if (PLAY_BY_STEP)
    how_many = 1;
  else
    how_many = (int)xv_get(slider_rate, PANEL_VALUE);
  while (krata < how_many){
    struct timeval tp4read;
    struct timezone tzp4read;
    krata++;
    if (CONNECTION_OK){
      int  ret_val;

      ret_val = read(s_id,(char *)&Update_Simultaneous_Interface,sizeof(Msg_simultaneous));
      if (ret_val == -1){
        int lk;
			
        for (lk = 0; lk < 5; lk++){
          if (ffp[lk])
            fclose(ffp[lk]);
        }

/*
        fprintf(stderr,"read from socket with socket id %d returns -1.\n",s_id);
*/
        EXECUTION_HAS_STOPED = 1;
/*
        fprintf(stderr,"I am here !!!! (1)\n");
*/
        xv_set(slider_rate, PANEL_NOTIFY_PROC, NULL, NULL);
        fprintf(stderr,"Program execution stops!\n");
        exit(0);
      }
			

      if (Update_Simultaneous_Interface.kind_of_mesg == -1){
        int lk;
			
        gettimeofday(&tp_final, &tzp_final);
        fprintf(stderr,"With User Interface: Runs for : %d sec \n",tp_final.tv_sec - tp.tv_sec);

        for (lk = 0; lk < 5; lk++){
          if (ffp[lk])
          fclose(ffp[lk]);
        }

        CONNECTION_OK = 0;
        EXECUTION_HAS_STOPED = 1;
/*
        fprintf(stderr,"I am here !!!! (2)\n");
*/
        notify_set_itimer_func(Slider_frame,NULL,ITIMER_REAL,NULL,NULL);
        show_final_results();
        break;
      }
      else{
       int from_which_canvas, count, c_sim;
       char info[256];
       FILE *fp[25];

       info[0] = '\0';
       from_which_canvas =
                   ret_system_canvas_begin(Update_Simultaneous_Interface.c_sim);
       c_sim = Update_Simultaneous_Interface.c_sim;
       LINE_NO = Update_Simultaneous_Interface.line_no;
       WHICH_WINDOW = Update_Simultaneous_Interface.which_window;

       /**** danalis code START ****/
 
/*********** The checking for SourceCodeActive is moved to default:
       if( SourceCodeActive && DataAvailable ){
***********/
       if( DataAvailable ){
         nchars = nbread(fifofd, fifobuf, 32);
         switch(nchars){
           case  0: DataAvailable = 0; /* We reached EOF       */
                    break;

           case -1: break;             /* Try at the next loop */

           case -2: perror("nbread");  /* An error occured     */
                    exit(-1);
                    break;

           default: if(SourceCodeActive){ /* If src Code Window is Active */
                      for(i4buf = 0; i4buf < nchars; i4buf++){
                        line[i4line] = fifobuf[i4buf];
                        if( line[i4line++] == '\n' ){
                          line[i4line] = '\0';
                          sscanf(line, "%s %d",FileName,&LineNumber);

                          /**** If a new file ****/
                          if( strcmp(OldFileName, FileName) ){
                            strcpy(OldFileName, FileName);
                            Change_Contents(FileName);
                          }
                          MarkLine(LineNumber, FileName);
                          i4line=0;
                        }
                      }
                    }
                    break;
         }
       }

       /**** danalis code END ****/

      for( count = from_which_canvas;
           count < ( from_which_canvas + CANVAS_PER_SYSTEM ); count++){
        int where;

        if (count == from_which_canvas + 0){
          double	help;
          char	tmp[100];

          where = 0;
          ddtb_total_misses[c_sim][0] += 
                                     Update_Simultaneous_Interface.ddtb_misses;
          ddtb_total_ref[c_sim][0] += 
                                     Update_Simultaneous_Interface.ddt_ref;
          if (Update_Simultaneous_Interface.ddt_ref)
            help = (Update_Simultaneous_Interface.ddtb_misses*100)/
                                         Update_Simultaneous_Interface.ddt_ref;
          else
            help = 0;

          if (help > max[c_sim][0])
            max[c_sim][0] = help;

          if (ZOOM[c_sim][0])
            help = help * ZOOM[c_sim][0];

          sprintf(tmp,"%d,%d", Update_Simultaneous_Interface.ddtb_misses,
                               Update_Simultaneous_Interface.ddt_ref);
          XDrawString(PDisplay, Pxid[count], Pgc[count],50,50,tmp,strlen(tmp));

          if (help < 0){
            continue;
          }
          if (count == 0 && ffp[0]){
            fprintf(ffp[0],"%lf\n",help);
          }

          if (Count_x2[c_sim] < 100){
            int k;

            array_COUNT_ARRAY_ddtb_misses[c_sim][Count_x2[c_sim]] = 
                                                             (int)(200 - help);
								
            XDrawLine(PDisplay,Pxid[count],Pgc[count],Count_x2[c_sim],
                      array_COUNT_ARRAY_ddtb_misses[c_sim][Count_x2[c_sim]],
                      Count_x2[c_sim],200);
          }
          else{
            int k;
					
            for (k = 0; k < 100; k++)
              array_COUNT_ARRAY_ddtb_misses[c_sim][k] = 200;

            array_COUNT_ARRAY_ddtb_misses[c_sim][0] = (int)(200 -help);
            XClearWindow(PDisplay, Pxid[count]);
            XDrawLine(PDisplay,Pxid[count], Pgc[count],Count_x2[c_sim],
                      array_COUNT_ARRAY_ddtb_misses[c_sim][Count_x2[c_sim]],
                      Count_x2[c_sim],200);
          }
          sprintf(info,"%d.DTlb:%d",count,ddtb_total_misses[c_sim][0]);
          XClearArea(PDisplay, Pxid[count], 5, 0, 95, 20, 0);
          XDrawString(PDisplay, Pxid[count],Pgc[count],5,10,info,strlen(info));
          sprintf(tmp,"%d,%d", Update_Simultaneous_Interface.ddtb_misses,
                               Update_Simultaneous_Interface.ddt_ref);
          XClearArea(PDisplay, Pxid[count], 50, 40, 40, 15, 0);
          XDrawString(PDisplay, Pxid[count], Pgc[count],50,50,tmp,strlen(tmp));

        }
        else
          if (count == from_which_canvas + 1){
            double help;
            char tmp[100];
 					
            where = 1;
            idtb_total_misses[c_sim][1] += 
                                      Update_Simultaneous_Interface.idtb_misses;
            idtb_total_ref[c_sim][1]+=Update_Simultaneous_Interface.idtb_ref;
            if (Update_Simultaneous_Interface.idtb_ref)
              help = ( Update_Simultaneous_Interface.idtb_misses*100 ) /
                       Update_Simultaneous_Interface.idtb_ref;
            else
              help = 0;
 
            if (help > max[c_sim][1])
              max[c_sim][1] = help;
 
            if (ZOOM[c_sim][1])
              help = help*ZOOM[c_sim][1];
 						
            if (help < 0){
              continue;
            }
 
            if (count == 1 && ffp[1])
            fprintf(ffp[1],"%lf\n",help);
 
            if (Count_x2[c_sim] < 100){
              int  k;
 
              array_COUNT_ARRAY_idtb_misses[c_sim][Count_x2[c_sim]] = 
                                                               (int)(200 -help);
              XDrawLine(PDisplay,Pxid[count],Pgc[count],
                        Count_x2[c_sim], 200, Count_x2[c_sim],
                        array_COUNT_ARRAY_idtb_misses[c_sim][Count_x2[c_sim]] );
            }
            else{
              int k;
 					
              for (k = 0; k < 100; k++)
                array_COUNT_ARRAY_idtb_misses[c_sim][k] = 200;
                array_COUNT_ARRAY_idtb_misses[c_sim][0] = (int)(200 -help);
                XClearWindow(PDisplay, Pxid[count]);
                XDrawLine(PDisplay,Pxid[count], Pgc[count],Count_x2[c_sim],
                          array_COUNT_ARRAY_idtb_misses[c_sim][Count_x2[c_sim]],
                           Count_x2[c_sim],200 );
            }
            sprintf(info,"%d.ITlb:%d",count,idtb_total_misses[c_sim][1]);
            XClearArea(PDisplay, Pxid[count], 5, 0, 95, 20, 0);
            XDrawString(PDisplay,Pxid[count],Pgc[count],5,10,info,strlen(info));
 
            sprintf(tmp,"%d,%d", Update_Simultaneous_Interface.idtb_misses,
                                 Update_Simultaneous_Interface.idtb_ref);
            XClearArea(PDisplay, Pxid[count], 50, 40, 40, 15, 0);
            XDrawString(PDisplay, Pxid[count],Pgc[count],50,50,tmp,strlen(tmp));
          }
          else
            if (count == from_which_canvas + 2){
              double help;
              char tmp[100];
				
              where = 2;
              dcache_total_misses[c_sim][2] += 
                                  Update_Simultaneous_Interface.d_cache_misses;
              dcache_total_ref[c_sim][2] +=
                                  Update_Simultaneous_Interface.d_cache_ref;
              if (Update_Simultaneous_Interface.d_cache_ref)
                help = ( Update_Simultaneous_Interface.d_cache_misses*100 ) /
                         Update_Simultaneous_Interface.d_cache_ref;
              else
                help = 0;
						
              if (help > max[c_sim][2])
                max[c_sim][2] = help;

              if (ZOOM[c_sim][2])
                help = help * ZOOM[c_sim][2];

              if (help < 0){
                continue;
              }

              if (count == 2 && ffp[2])
                fprintf(ffp[2],"%lf\n",help);

              if (Count_x2[c_sim] < 100){
                int k;

                array_COUNT_ARRAY_d_cache_misses[c_sim][Count_x2[c_sim]] = 
                                                             (int)(200 - help);
                XDrawLine(PDisplay, Pxid[count], Pgc[count], Count_x2[c_sim],
                       array_COUNT_ARRAY_d_cache_misses[c_sim][Count_x2[c_sim]],
                       Count_x2[c_sim],200);
              }
              else{
                int k;

                for (k = 0; k < 100; k++)
                  array_COUNT_ARRAY_d_cache_misses[c_sim][k] = 200;
                array_COUNT_ARRAY_d_cache_misses[c_sim][0] = (int)(200 -help);
                XClearWindow(PDisplay, Pxid[count]);
                XDrawLine(PDisplay,Pxid[count], Pgc[count],Count_x2[c_sim],
                       array_COUNT_ARRAY_d_cache_misses[c_sim][Count_x2[c_sim]],
                       Count_x2[c_sim],200);
              }
              sprintf(info,"%d.DCache:%d",count,dcache_total_misses[c_sim][2]);
              XClearArea(PDisplay, Pxid[count], 5, 0, 95, 20, 0);
              XDrawString(PDisplay, Pxid[count], Pgc[count], 5, 10, info,
                                                                strlen(info));
              sprintf(tmp,"%d,%d", Update_Simultaneous_Interface.d_cache_misses,
                                   Update_Simultaneous_Interface.d_cache_ref);
              XClearArea(PDisplay, Pxid[count], 50, 40, 40, 15, 0);
              XDrawString(PDisplay, Pxid[count], Pgc[count], 50, 50, tmp,
                                                                 strlen(tmp));
            }
            else
              if (count == from_which_canvas + 3){
                double help;
                char tmp[100];

                where = 3;
                icache_total_misses[c_sim][3] += 
                                  Update_Simultaneous_Interface.i_cache_misses;
                icache_total_ref[c_sim][3] += 
                                  Update_Simultaneous_Interface.i_cache_ref;
                if (Update_Simultaneous_Interface.i_cache_ref)
                  help = ( Update_Simultaneous_Interface.i_cache_misses*100 ) /
                           Update_Simultaneous_Interface.i_cache_ref;
                else
                  help = 0;

                if (help > max[c_sim][3])
                  max[c_sim][3] = help;

                if (ZOOM[c_sim][3])
                  help = help * ZOOM[c_sim][3];
						
                if (count == 3 && ffp[3])
                  fprintf(ffp[3],"%lf\n",help);

                if (Count_x2[c_sim] < 100){
                  int k;

                  array_COUNT_ARRAY_i_cache_misses[c_sim][Count_x2[c_sim]] = 
                                                             (int)(200 - help);
                  XDrawLine(PDisplay, Pxid[count], Pgc[count],
                            Count_x2[c_sim], 200, Count_x2[c_sim],
                      array_COUNT_ARRAY_i_cache_misses[c_sim][Count_x2[c_sim]]);
                }
                else{
                  int k;
					
                  for (k = 0; k < 100; k++)
                    array_COUNT_ARRAY_i_cache_misses[c_sim][k] = 200;
                  array_COUNT_ARRAY_i_cache_misses[c_sim][0] = (int)(200-help);

                  XClearWindow(PDisplay, Pxid[count]);
                  XDrawLine(PDisplay,Pxid[count], Pgc[count],Count_x2[c_sim],
                       array_COUNT_ARRAY_i_cache_misses[c_sim][Count_x2[c_sim]],
                       Count_x2[c_sim],200);
                }
                sprintf(info, "%d.ICache:%d", count,
                                              icache_total_misses[c_sim][3]);
                XClearArea(PDisplay, Pxid[count], 5, 0, 95, 20, 0);
                XDrawString(PDisplay, Pxid[count], Pgc[count], 5, 10, info,
                                                                  strlen(info));
                sprintf(tmp,"%d,%d",
                                   Update_Simultaneous_Interface.i_cache_misses,
                                   Update_Simultaneous_Interface.i_cache_ref);
                XClearArea(PDisplay, Pxid[count], 50, 40, 40, 15, 0);
                XDrawString(PDisplay, Pxid[count], Pgc[count], 50, 50, tmp,
                                                                   strlen(tmp));

              }
              else
                if (count == from_which_canvas + 4){
                  double help;
                  char tmp[100];

                  where = 4;
                  sec_level_cache_total_misses[c_sim][4] += 
                                  Update_Simultaneous_Interface.u_cache_misses;
                  sec_level_cache_total_ref[c_sim][4] += 
                                  Update_Simultaneous_Interface.u_cache_ref;
                  if (Update_Simultaneous_Interface.u_cache_ref)
                    help = (Update_Simultaneous_Interface.u_cache_misses*100) /
                            Update_Simultaneous_Interface.u_cache_ref;
                  else
                    help = 0;

                  if (help > max[c_sim][4])
                    max[c_sim][4] = help;

                  if (ZOOM[c_sim][4])
                    help = help*ZOOM[c_sim][4];

                  if (count == 4 && ffp[4])
                    fprintf(ffp[4],"%lf\n",help);

                  if (Count_x2[c_sim] < 100){
                    int k;

                    array_COUNT_ARRAY_u_cache_misses[c_sim][Count_x2[c_sim]] =
                                                             (int)(200 - help);
                    XDrawLine(PDisplay,Pxid[count],Pgc[count],
                              Count_x2[c_sim],200,Count_x2[c_sim],
                      array_COUNT_ARRAY_u_cache_misses[c_sim][Count_x2[c_sim]]);
                  }
                  else{
                    int k;
					
                    for (k = 0; k < 100; k++)
                      array_COUNT_ARRAY_u_cache_misses[c_sim][k] = 200;
                    Count_x2[c_sim] = 0; /* mono edw ! */
                    for (k = 0; k < 5; k++){
                      printf("max[%d][%d] = %d \n",c_sim,k,max[c_sim][k]);
                      if (max[c_sim][k] <=10)
                        ZOOM[c_sim][k] = 10;
                      else
                        if (max[c_sim][k] < 50)
                          ZOOM[c_sim][k] = 2;
                        else
                          ZOOM[c_sim][k] = 0;
                      max[c_sim][k] = 0;
                      XClearWindow(PDisplay, Pxid[from_which_canvas+k]);
                    }
                    array_COUNT_ARRAY_u_cache_misses[c_sim][0]=(int)(200-help);
                    XClearWindow(PDisplay, Pxid[count]);
                    XDrawLine(PDisplay,Pxid[count], Pgc[count],Count_x2[c_sim],
                       array_COUNT_ARRAY_u_cache_misses[c_sim][Count_x2[c_sim]],
                       Count_x2[c_sim],200);
                    printf("\n");
                  }
                  sprintf(info,"%d.Ucache:%d",count,
                                        sec_level_cache_total_misses[c_sim][4]);
                  XClearArea(PDisplay, Pxid[count], 5, 0, 95, 20, 0);
                  XDrawString(PDisplay, Pxid[count], Pgc[count], 5, 10, info,
                                                                  strlen(info));
                  sprintf(tmp,"%d,%d",
                                   Update_Simultaneous_Interface.u_cache_misses,
                                   Update_Simultaneous_Interface.u_cache_ref);
                  XClearArea(PDisplay, Pxid[count], 50, 40, 40, 15, 0);
                  XDrawString(PDisplay, Pxid[count], Pgc[count], 50, 50, tmp,
                                                                   strlen(tmp));

                }
                XDrawLine(PDisplay,Pxid[count],Pgc[count],5,200,5,1);
                if (!ZOOM[c_sim][where]){
                  XSetForeground(PDisplay,Pgc[count],
                                                  Pwin_colors[count][c_sim+4]);
                  XDrawString(PDisplay, Pxid[count], Pgc[count],8,180,"20%",3);
                  XDrawString(PDisplay, Pxid[count], Pgc[count],8,160,"40%",3);
                  XDrawString(PDisplay, Pxid[count], Pgc[count],8,140,"60%",3);
                  XDrawString(PDisplay, Pxid[count], Pgc[count],8,120,"80%",3);
                  XDrawString(PDisplay, Pxid[count], Pgc[count],8,100,"100%",4);
                }
                else
                  if (ZOOM[c_sim][where] == 2){
                    XSetForeground(PDisplay,Pgc[count],
                                                  Pwin_colors[count][c_sim+4]);
                    XDrawString(PDisplay,Pxid[count],Pgc[count],8,180,"10%",3);
                    XDrawString(PDisplay,Pxid[count],Pgc[count],8,160,"20%",3);
                    XDrawString(PDisplay,Pxid[count],Pgc[count],8,140,"30%",3);
                    XDrawString(PDisplay,Pxid[count],Pgc[count],8,120,"40%",3);
                    XDrawString(PDisplay,Pxid[count],Pgc[count],8,100,"50%",3);
                  }
                  else
                    if (ZOOM[c_sim][where] == 10){
                      XSetForeground(PDisplay,Pgc[count],
                                                   Pwin_colors[count][c_sim+4]);
                      XDrawString(PDisplay,Pxid[count],Pgc[count],8,180,"2%",2);
                      XDrawString(PDisplay,Pxid[count],Pgc[count],8,160,"4%",2);
                      XDrawString(PDisplay,Pxid[count],Pgc[count],8,140,"6%",2);
                      XDrawString(PDisplay,Pxid[count],Pgc[count],8,120,"8%",2);
                      XDrawString(PDisplay,Pxid[count],Pgc[count],8,100,"10%",
                                                                             3);
                    }
      }
      Count_x2[c_sim]++;

/*********************

fprintf(stderr,"Update_Simultaneous_Interface.ddtb_misses = %d \n",Update_Simultaneous_Interface.ddtb_misses);
fprintf(stderr,"Update_Simultaneous_Interface.idtb_misses = %d \n",Update_Simultaneous_Interface.idtb_misses);
fprintf(stderr,"Update_Simultaneous_Interface.d_cache_misses = %d \n",Update_Simultaneous_Interface.d_cache_misses);
fprintf(stderr,"Update_Simultaneous_Interface.i_cache_misses = %d \n",Update_Simultaneous_Interface.i_cache_misses);
fprintf(stderr,"Update_Simultaneous_Interface.u_cache_misses = %d \n",Update_Simultaneous_Interface.u_cache_misses);
fprintf(stderr,"Update_Simultaneous_Interface.kind_of_mesg = %d \n",Update_Simultaneous_Interface.kind_of_mesg);
fprintf(stderr,"Update_Simultaneous_Interface.c_sim = %d \n",Update_Simultaneous_Interface.c_sim);
*********************/
      }
    }
  }
}

void
quit_Slider_frame()
{
	notify_set_itimer_func(Slider_frame,NULL,ITIMER_REAL,NULL,NULL);
	HOW_MANY = 0;
	EXEC_INTERF_START_OK = 0;
	EXECUTION_HAS_STOPED = 0;
	current_system = 0;
	xv_destroy_safe(Pframe);
	xv_destroy_safe(Slider_frame);
}

int
ret_system_canvas_begin(c_sim)
int	c_sim;
{
	return	(c_sim*CANVAS_PER_SYSTEM);
}

int
By_Step_Procedure()
{
	if (!EXECUTION_HAS_STOPED)
	{
		PLAY_BY_STEP = 1;
		Show_Simultaneous_execution_traces();
	}
	else
		xv_set(Steper, PANEL_INACTIVE, TRUE, NULL);
}
