#include "defs.h"
#include "SimultParams.h"

Panel 		ChooseSimParPanel;

Panel_item	InstrTlbText, DataTlbText, InstrCacheText;
Panel_item	DataCacheText, SecLevelCacheText;

Panel_item	InstrTlbChoice, DataTlbChoice, InstrCacheChoice;
Panel_item	DataCacheChoice, SecLevelCacheChoice;

extern	Panel_item ChooseCommand, ChooseMoreParams;

int		OK_ChooseFunction();
extern	int	HOW_MANY;
int		current_system = 0;


void
SimultParametersChoosen()
{
	Frame	frame;
	Menu	menu;
	void	simult_quit(); 
	int		simult_numeric_text();
	int		choose_selected(), choose_toggle_selected();


	current_system = 0;
	frame = xv_create(XV_NULL, FRAME,
		FRAME_LABEL,		"Choose Parameters",
		XV_WIDTH,		500,
		XV_HEIGHT,		250,
		FRAME_SHOW_FOOTER,	TRUE,
	NULL);

    	ChooseSimParPanel = xv_create(frame, PANEL, NULL);

	xv_set(canvas_paint_window(ChooseSimParPanel), NULL);

    	InstrTlbText = (Panel_item)xv_create(ChooseSimParPanel, PANEL_NUMERIC_TEXT,
		PANEL_LABEL_STRING,	"Instruction TLB Size:",
		PANEL_VALUE,		8,
		PANEL_MAX_VALUE,	2048,
		PANEL_MIN_VALUE,	0,
		PANEL_NOTIFY_PROC,	simult_numeric_text,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	InstrTlbChoice = (Panel_item)xv_create(ChooseSimParPanel, PANEL_CHOICE,
		PANEL_CHOICE_STRINGS,   "Positions",NULL,
		PANEL_NOTIFY_PROC,      choose_selected,
		PANEL_CLIENT_DATA,      frame,
	NULL);

    	DataTlbText = (Panel_item)xv_create(ChooseSimParPanel, PANEL_NUMERIC_TEXT,
		PANEL_LABEL_STRING,	"Data TLB Size:",
		PANEL_VALUE,		8,
		PANEL_MAX_VALUE,	2048,
		PANEL_MIN_VALUE,	0,
		PANEL_NOTIFY_PROC,	simult_numeric_text,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	DataTlbChoice = xv_create(ChooseSimParPanel, PANEL_CHOICE,
		PANEL_CHOICE_STRINGS,   "Positions",NULL,
		PANEL_NOTIFY_PROC,      choose_selected,
		PANEL_CLIENT_DATA,      frame,
	NULL);

    	InstrCacheText = (Panel_item)xv_create(ChooseSimParPanel, PANEL_NUMERIC_TEXT,
		PANEL_LABEL_STRING,	"Instruction Cache Size:",
		PANEL_VALUE,		5,
		PANEL_MAX_VALUE,	2048,
		PANEL_MIN_VALUE,	0,
		PANEL_NOTIFY_PROC,	simult_numeric_text,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	InstrCacheChoice = (Panel_item)xv_create(ChooseSimParPanel, PANEL_CHOICE,
		PANEL_CHOICE_STRINGS,   "Kb","Mb",NULL,
		PANEL_NOTIFY_PROC,      choose_selected,
		PANEL_CLIENT_DATA,      frame,
	NULL);

    	DataCacheText = (Panel_item)xv_create(ChooseSimParPanel, PANEL_NUMERIC_TEXT,
		PANEL_LABEL_STRING,	"Data Cache Size:",
		PANEL_VALUE,		128,
		PANEL_MAX_VALUE,	2048,
		PANEL_MIN_VALUE,	0,
		PANEL_NOTIFY_PROC,	simult_numeric_text,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	DataCacheChoice = (Panel_item)xv_create(ChooseSimParPanel, PANEL_CHOICE,
		PANEL_CHOICE_STRINGS,   "Kb","Mb",NULL,
		PANEL_NOTIFY_PROC,      choose_selected,
		PANEL_CLIENT_DATA,      frame,
	NULL);

    	SecLevelCacheText = (Panel_item)xv_create(ChooseSimParPanel, PANEL_NUMERIC_TEXT,
		PANEL_LABEL_STRING,	"Second Level Cache Size:",
		PANEL_VALUE,		256,
		PANEL_MAX_VALUE,	4096,
		PANEL_MIN_VALUE,	0,
		PANEL_NOTIFY_PROC,	simult_numeric_text,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	SecLevelCacheChoice = (Panel_item)xv_create(ChooseSimParPanel, PANEL_CHOICE,
		PANEL_CHOICE_STRINGS,   "Kb","Mb",NULL,
		PANEL_NOTIFY_PROC,      choose_selected,
		PANEL_CLIENT_DATA,      frame,
	NULL);

	xv_create(ChooseSimParPanel, PANEL_BUTTON,
		PANEL_LABEL_STRING,     "Ok",
		PANEL_NOTIFY_PROC,      OK_ChooseFunction,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	xv_create(ChooseSimParPanel, PANEL_BUTTON,
		PANEL_LABEL_STRING,     "Quit",
		PANEL_NOTIFY_PROC,      simult_quit,
		PANEL_CLIENT_DATA,	frame,
	NULL);

	/*
	xv_set(ChooseMoreParams, PANEL_INACTIVE, TRUE, NULL);
	*/
	xv_main_loop(frame);
}

int
choose_toggle_selected(item, value, event)
Panel_item item;
unsigned value;
Event *event;
{
    	char 	buf[32];
    	Frame 	frame = xv_get(item, PANEL_CLIENT_DATA);
    	int 	i;

    	buf[0] = 0;
    	if (event_id(event) == MS_LEFT) 
	{
		for (i = 0; value; i++, value >>= 1)
	    	if (value & 1)
			sprintf(buf+strlen(buf), "%s%c ",
		    		xv_get(item, PANEL_CHOICE_STRING, i),
		    		(value >> 1)? ',' : ' ');
		xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);

		return XV_OK;
	}
	return XV_ERROR;
}

int
choose_selected(item, value, event)
Panel_item item;
int value;
Event *event;
{
	char 	buf[32];
    	Frame 	frame = xv_get(item, PANEL_CLIENT_DATA);

	if (event_id(event) == MS_LEFT) 
	{
		sprintf(buf, "\"%s\" selected",
	    	xv_get(item, PANEL_CHOICE_STRING, panel_get_value(item)));
		xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);

		return XV_OK;
    	}
    	return XV_ERROR;
}


simult_numeric_text(item, event)
Panel_item item;
Event *event;
{
    	char buf[32];

    	Frame frame = xv_get(item, PANEL_CLIENT_DATA);

    	sprintf(buf, "\"%s\" set to %d",
       		(char *)xv_get(item, PANEL_LABEL_STRING), (int)xv_get(item, PANEL_VALUE));
    	xv_set(frame, FRAME_RIGHT_FOOTER, buf, NULL);
    	return PANEL_NEXT;
}

OK_ChooseFunction()
{
	char 		buf[32];
	Frame 		frame;

	frame = (Frame)xv_get(InstrTlbText,PANEL_CLIENT_DATA);

	xv_set(ChooseCommand, PANEL_INACTIVE, FALSE, NULL);

	InstrTLBParams[current_system] = (int)xv_get(InstrTlbText, PANEL_VALUE);
	xv_set(InstrTlbText,PANEL_VALUE,8,NULL);
	strcpy(InstrTLBWhat[current_system],(char *)xv_get(InstrTlbChoice, PANEL_CHOICE_STRING, panel_get_value(InstrTlbChoice)));

	DataTLBParams[current_system] = (int)xv_get(DataTlbText,PANEL_VALUE);
	xv_set(DataTlbText,PANEL_VALUE,8,NULL);
	strcpy(DataTLBWhat[current_system],(char *)xv_get(DataTlbChoice, PANEL_CHOICE_STRING, panel_get_value(DataTlbChoice)));

	InstrCacheParams[current_system] = (int)xv_get(InstrCacheText,PANEL_VALUE);
	xv_set(InstrCacheText,PANEL_VALUE,5,NULL);
	strcpy(InstrCacheWhat[current_system],(char *)xv_get(InstrCacheChoice,PANEL_CHOICE_STRING, panel_get_value(InstrCacheChoice)));

	DataCacheParams[current_system] = (int)xv_get(DataCacheText,PANEL_VALUE);
	xv_set(DataCacheText,PANEL_VALUE,128,NULL);
	strcpy(DataCacheWhat[current_system],(char *)xv_get(DataCacheChoice,PANEL_CHOICE_STRING, panel_get_value(DataCacheChoice)));

	SecLevelCacheParams[current_system] = (int)xv_get(SecLevelCacheText,PANEL_VALUE);	
	xv_set(SecLevelCacheText,PANEL_VALUE,4,NULL);
	strcpy(SecLevelCacheWhat[current_system],(char *)xv_get(SecLevelCacheChoice,PANEL_CHOICE_STRING, panel_get_value(SecLevelCacheChoice)));

	fprintf(stderr,"InstrTLBParams[0] = %d \n",InstrTLBParams[0]);	
	fprintf(stderr,"InstrTLBWhat[0] = %s \n",InstrTLBWhat[0]);

	fprintf(stderr,"DataTLBParams[0] = %d \n",DataTLBParams[0]);
	fprintf(stderr,"DataTLBWhat[0] = %s \n",DataTLBWhat[0]);

	fprintf(stderr,"InstrCacheParams[0] = %d \n",InstrCacheParams[0]);
	fprintf(stderr,"InstrCacheWhat[0] = %s \n",InstrCacheWhat[0]);

	fprintf(stderr,"DataCacheParams[0] = %d \n",DataCacheParams[0]);
	fprintf(stderr,"DataCacheWhat[0] = %s \n",DataCacheWhat[0]);

	fprintf(stderr,"SecLevelCacheParams[0] = %d \n",SecLevelCacheParams[0]);
	fprintf(stderr,"SecLevelCacheWhat[0] = %s \n",SecLevelCacheWhat[0]);

	current_system++;
	
	if (current_system == HOW_MANY+1) /* it was == 5 until now ... */
		xv_destroy_safe(frame);
}


void
simult_quit(item, event)
Panel_item item;
Event *event;
{
    	Frame frame = xv_get(item, PANEL_CLIENT_DATA);
	current_system = 0;
    	if (event_id(event) == MS_LEFT)
		xv_destroy_safe(frame);
}
