#include "Tcp.h"
#include "SimultParams.h"

void 			drop_connection();
int 			establish_connection(char *hostname);
int				get_client_connection();
void			client_actions();
void			client_send_simultParams();

struct hostent 		*host;
struct sockaddr_in 	sa;
int			s_id = 0;			/* socket descriptor */
int			connection_established = 0;	/* 1 if connected */
char			inbuf[MSGLEN+1], outbuf[MSGLEN+1];
int			nread = 0, nwrite = 0;

int					SHADE_PID;
extern	char		INTERF_COMMAND[128];
extern	int             InstrCacheSize;
extern	int             DataCacheSize;
extern	int             InstrTlbSize;
extern	int             DataTlbSize;
extern	int             SecondLeveCacheSize;
extern	int		HOW_MANY;
extern	int		READ_COMMANDS_FROM_FILE;

/*
void
main()
{
	get_client_connection();
}
*/

int
get_client_connection()
{
	char		hostname[128];

	gethostname(hostname,128);
/*	fprintf(stderr,"Hostname: %s \n",hostname);*/
	if (establish_connection(hostname)>= 0)
		connection_established = 1;
	else
	{
		fprintf(stderr,"No connection ...\n");
		fprintf(stderr,"Program execution stops.\n");
		if (!s_id)
			close(s_id);
		return 0;
	}

	client_actions();
	client_send_simultParams();
	return 1;
}

void
client_actions()
{
	Msg_test	tmp;

	nread = read(s_id, &tmp, sizeof(Msg_test));
/*  fprintf(stdout, "inbuf is %s\n", inbuf);      */
	SHADE_PID = tmp.pid;
/****************** 
    fprintf(stderr,"Process id is %d \n",tmp.pid);
    fprintf(stderr,"a1 = %d \n",tmp.a1);
    fprintf(stderr,"a2 = %d \n",tmp.a2);
******************/
	
	tmp.a1 = 12;
	tmp.a2 = 1024;
	strcpy(tmp.command,INTERF_COMMAND);
	tmp.InstrCacheSize = InstrCacheSize;
	tmp.DataCacheSize = DataCacheSize;
	tmp.InstrTlbSize = InstrTlbSize;
	tmp.DataTlbSize = DataTlbSize;
	tmp.SecondLeveCacheSize = SecondLeveCacheSize;
	tmp.how_many = HOW_MANY;
	tmp.read_from_file = READ_COMMANDS_FROM_FILE;

	nwrite = write(s_id, &tmp, sizeof(Msg_test));
}

void
client_send_simultParams()
{
	SimultParamsStruct	tmp;
	int	nwrite,i;

	for (i = 0; i < 5; i++)
	{
		tmp.InstrTLBParams[i] = InstrTLBParams[i];
		tmp.DataTLBParams[i] = DataTLBParams[i];
		tmp.InstrCacheParams[i] = InstrCacheParams[i];
		tmp.DataCacheParams[i] = DataCacheParams[i];
		tmp.SecLevelCacheParams[i] = SecLevelCacheParams[i];

		strcpy(tmp.InstrTLBWhat[i],InstrTLBWhat[i]);
		strcpy(tmp.DataTLBWhat[i],DataTLBWhat[i]);
		strcpy(tmp.InstrCacheWhat[i],InstrCacheWhat[i]);
		strcpy(tmp.DataCacheWhat[i],DataCacheWhat[i]);
		strcpy(tmp.SecLevelCacheWhat[i],SecLevelCacheWhat[i]);
	}

	nwrite = write(s_id, &tmp, sizeof(SimultParamsStruct));
}

int
establish_connection(char *hostname)
{
	if ((host = gethostbyname(hostname)) == NULL)
	{
		fprintf(stderr, "no information found for host %s.\n",hostname);
		return -1;
	}
	else
	{
/*
	        fprintf(stdout, "connecting to %s.\n", hostname);
*/

	        /* set address... */
	        bzero(&sa, sizeof(struct sockaddr_in));
	        bcopy(host->h_addr, (char *)&sa.sin_addr, host->h_length);
	        sa.sin_family = host->h_addrtype;
	        sa.sin_port = htons((u_short)PORT);

	    if ((s_id = socket(host->h_addrtype, SOCK_STREAM, 0)) < 0)
		{
			perror("on socket creation");
			return -1;
		}
	    else
		{
			int	ret;

/******************
			fprintf(stderr,"client.c: s_id is %d \n",s_id);
			fprintf(stderr,"client.c: &s_id is %x(hex) \n",&s_id);
*******************/

			ret = connect(s_id, &sa, sizeof(sa));
/*          fprintf(stderr,"connect() returns %d \n",ret);  */
			if (ret == -1)
			{
				perror("on connect");
				return -1;
			}
			else
			{
			/*********************
				CLEAR(outbuf);
				sprintf(outbuf, "%s\0", OPENMSG);
				nwrite = write(s_id, outbuf, MSGLEN);

				do
				{
					nread = read(s_id, inbuf, MSGLEN);
					fprintf(stdout, "%s", inbuf);
				} while ((nread != 0) &&
					 !ok_in(inbuf) && !error_in(inbuf));
				if (nread == 0)
				{
					fprintf(stderr, "connection lost.\n");
					drop_connection(s_id);
				}
				return s_id;
				fprintf(stderr,"Connected ..\n");
			*********************/
				return 1;
			}
		}
	}
}

void
drop_connection(int s_id)
{
	shutdown(s_id, 0);
	close(s_id);
	connection_established = 0;
}

