#include "defs.h"
#include "my_sockets.h"
#include "SimultParams.h"
#include <signal.h>

#ifndef SIGUSR1
#define SIGUSR1 30
#endif
#ifndef SIGUSR2
#define SIGUSR2 31
#endif

Xv_Font 		greek;
Xv_Font 		color_font;

Menu 			menu[10] , submenu[6][6];
Frame 			Initial,Beginer;
Canvas  		MainCanvas;
Panel 			panel, QuitB,Button[5],TmpPanel,PlayPanel,FilePanel,RESTARTB;
Panel_item		StartB,ChooseCommand,ChooseMoreParams, Parallel_Exec;
Panel_item		SourceCodeButton;
Panel			MainPanel, ComparePanel, SharedPanel, HelpMenu, TermSWButton;
Panel_item 		msg_item , helper[3], ParamChoices;
Window			MainWindow;

Display 		*dpy;
Display 		*MainDpy;
int				START_SIMULATION = 0;

Tty				initial_tty;
extern	char    *my_argv[]; 

extern	void	Quit_exec();
extern	int		selected();
extern	int		get_client_connection();
extern	void	InitInterface();
extern	void	init_total_cms();
extern	void	Choose_ICACHE_Size();
extern	void	Choose_DCACHE_Size();
extern	void	Choose_ITLB_Size();
extern	void	Choose_DTLB_Size();
extern	void	Choose_SecLevelCache_Size();
extern	void	tty_execute_cachesim5();
extern	void	choose_simulation_command();
extern	void	Choose_More_Parameters();
extern	void	ExecSimultWithDiffParams();
extern	void	SimultParametersChoosen();
extern	void	choose_source_path();
extern	void	help();
extern	void	q_help();
extern	void	show_final_results();

extern	int		s_id;
int				CONNECTION_OK = 0;

static XColor   fg = {0L, 65535, 65535, 65535};
static XColor   bg = {0L, 0, 0, 0};


extern			Cms	total_cms;

void 			close();
void			quit();
void			start_simulation();
void			start_interface_simulation();
void			init_parameter_arrays();
int				First_Communication();

void test_signal(){
  ; 
/*
    fprintf(stderr,"*********************\n");
    fprintf(stderr,"*********************\n");
    fprintf(stderr,"signal SIGUSR1 caught\n");
    fprintf(stderr,"*********************\n");
    fprintf(stderr,"*********************\n");
*/
}

Notify_value my_main() {
	static	int	flag = 0;
	char	*buf;
	buf = (char *)malloc(sizeof(char));

    signal(SIGUSR1, test_signal);
    signal(SIGUSR2, start_interface_simulation);


	init_parameter_arrays();
	if (!flag)
	{

	init_total_cms();

	greek = (Xv_font)xv_find(NULL, FONT, FONT_NAME, FONT_USED, NULL);
	color_font = (Xv_font)xv_find(NULL, FONT, FONT_NAME, FONT_COLOR, NULL);

	Initial = (Frame)xv_create(XV_NULL, FRAME,
			   FRAME_LABEL, 	" C A C H I N G ",
			   XV_FONT, 		greek,
			   XV_WIDTH,		500,
			   XV_HEIGHT,		200,
			   XV_X,			500,
			   XV_Y,			0,	
				
		   NULL);

  dpy = (Display *)xv_get(Initial,XV_DISPLAY);

/*  fprintf(stderr,"CMS_CONTROL_COLORS = %d \n",CMS_CONTROL_COLORS); */

  MainPanel = (Panel)xv_create(Initial, PANEL,
			PANEL_LAYOUT, PANEL_HORIZONTAL,
			WIN_DYNAMIC_VISUAL,   TRUE,
			WIN_CMS,        	   total_cms,
            NULL);

                       /*   11 , 2 , 12   */
  xv_set(MainPanel,WIN_BACKGROUND_COLOR ,CMS_CONTROL_COLORS - 3,NULL); 

/*
 *********************************************************************
 *********************** Buttons start here .... *********************
 *********************************************************************
*/

		ParamChoices = (Panel_item)xv_create(MainPanel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Choose Configuration Number",
			PANEL_ITEM_COLOR,	CMS_CONTROL_COLORS+3,
			PANEL_NOTIFY_PROC,	Choose_More_Parameters,
			XV_X,				10,
			XV_Y,				10,
		NULL);

	ChooseMoreParams = (Panel_item)xv_create(MainPanel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Choose System Parameters",
			PANEL_ITEM_COLOR,	CMS_CONTROL_COLORS+3,
			PANEL_NOTIFY_PROC,	SimultParametersChoosen,
			XV_X,				250,
			XV_Y,				10,
		NULL);

	SourceCodeButton = (Panel_item)xv_create(MainPanel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Initialize Source Code Window",
			PANEL_ITEM_COLOR,	CMS_CONTROL_COLORS+3,
			PANEL_NOTIFY_PROC,	help,
			XV_X,				100,
			XV_Y,				80,
		NULL);

	ChooseCommand = (Panel_item)xv_create(MainPanel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Choose Simulation Command",
			PANEL_ITEM_COLOR,	CMS_CONTROL_COLORS+3,
			PANEL_NOTIFY_PROC,	choose_simulation_command,
			XV_X,				10,
			XV_Y,				150,
		NULL);

	StartB = (Panel_item)xv_create(MainPanel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Start Simulation",
			PANEL_ITEM_COLOR,	CMS_CONTROL_COLORS+3,
			PANEL_NOTIFY_PROC,	start_simulation,
			PANEL_INACTIVE,		TRUE,
			XV_X,				250,
			XV_Y,				150,
		NULL);

	flag = 1;

	window_fit(Initial);
	xv_main_loop(Initial);
	}
}

void close()
{
	return;
}

void
quit()
{
	int	fp;

	if (fp=open("/tmp/semaphore",O_CREAT+O_EXCL)<0)
		return;
	close(fp);
	unlink("/tmp/semaphore");

	drop_connection(s_id);
	Quit_exec();
	exit(0);
}

struct itimerval	timer;

void
call_my_main(item,value)
Panel_item	item;
int		value;
{
	timer.it_value.tv_usec =  20 ;
	timer.it_interval.tv_usec = (value + 20) * 1000;
	notify_set_itimer_func(Beginer,my_main,ITIMER_REAL,&timer,NULL);
}

extern	int	BECAME_THE_TTY;
extern	void	mesg_not_creation();

void
start_simulation()
{
	int	n;
	int	fp;
    int i4sleep;

	xv_set(ParamChoices,PANEL_INACTIVE, TRUE, NULL);
	xv_set(ChooseMoreParams, PANEL_INACTIVE, TRUE, NULL);
	xv_set(StartB, PANEL_INACTIVE, TRUE, NULL);

	fp=open("/tmp/semaphore",O_CREAT+O_EXCL);
	if (fp < 0)
		;	
	else
		close(fp);

	tty_execute_cachesim5();

/********************* danalis code start *********************/
	xv_destroy_safe(Initial);
/********************* danalis code end ***********************/
}

int
First_Communication()
{
		int	ret;

		ret = get_client_connection();
/*
		fprintf(stderr,"****s_id is %d \n",s_id);
*/
		CONNECTION_OK = 1;
		return 1;
}

void
start_interface_simulation()
{
		static	int	first_time = 0;
	
		unlink("/tmp/semaphore");
		
		if (!first_time)
		{

			First_Communication();
			first_time = 1;
		}
		else
		{
/*
			fprintf(stderr,"I am here ... \n");
*/
			client_actions();
			CONNECTION_OK = 1;
			client_send_simultParams();
			return;
		}
		ExecSimultWithDiffParams();
}


void
init_parameter_arrays()
{
	int	i;
	
	for (i = 0; i < 5; i++){
	
		InstrTLBParams[i] = 8;
		DataTLBParams[i] = 8;
		InstrCacheParams[i] = 5;
		DataCacheParams[i] = 128;
		SecLevelCacheParams[i] = 256;
	
		strcpy(InstrTLBWhat[i], "Positions");
		strcpy(DataTLBWhat[i], "Positions");
		strcpy(InstrCacheWhat[i], "Kb");
		strcpy(DataCacheWhat[i], "Kb");
		strcpy(SecLevelCacheWhat[i], "Kb");
	}
}

void 
produce_gnuplot_file(from, to, fname)
int	from;
int	to;
char	*fname;
{
    FILE *pp;
    int pid;

    pp = popen("gnuplot","w");

    if (!pp)
    {
/*
            fprintf(stderr,"Error in popen\n");
*/
            exit(-1);
    }
    fprintf(pp,"set ylabel \"\% misses \"\n");
    fprintf(pp,"set xlabel \"Each point refers to 1000 memory references\"\n");
    fprintf(pp,"plot [] [\"%d\":\"%d\"] \"%s\" w steps \"\n",from, to, fname);
    fflush(pp);
}

