#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/textsw.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/cms.h>
#include <xview/scrollbar.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>


Canvas			my_canvas;
Cms				my_cms;
Panel_item      quit_file_help;
Textsw         	my_textsw;
Scrollbar		my_sb;

int				PLAY_WITH_SOURCE_CODE = 0;
int             SourceCodeActive = 0;
int				Src_Not_Here = 0;

void			q_help();
void			PlaySourceCode();
void			help();
void  			canvas_repaint_proc();
void			Change_Contents();
/**** danalis code START ****/
void			MarkLine();
/**** danalis code END ****/

void help() {
  Frame frame;
  Panel panel;

  SourceCodeActive = 1;

  my_cms = (Cms)xv_create(NULL,            CMS,              
                          CMS_NAME,        "palette",
                          CMS_CONTROL_CMS, TRUE,
                          CMS_TYPE,        XV_STATIC_CMS,
                          CMS_SIZE,        CMS_CONTROL_COLORS + 4,
                                                               NULL);

  frame = (Frame)xv_create(XV_NULL,     FRAME,
                           FRAME_LABEL, NULL,
                           XV_WIDTH,    400,
                           XV_HEIGHT,   400,
                                        NULL);


  panel = (Panel)xv_create(frame,     PANEL,
                           XV_WIDTH,  400,
                           XV_HEIGHT, 50,
                           XV_X,      0,
                           XV_Y,      0,
                                    NULL);

  quit_file_help = (Panel_item)xv_create(panel,              PANEL_BUTTON,
                                         PANEL_LABEL_STRING, "Dismiss",
                                         PANEL_NOTIFY_PROC,  q_help,
                                         XV_X,               150,
                                         XV_Y,               25,
                                                            NULL);

  my_textsw = xv_create(frame,                TEXTSW,
                        XV_X,                 30,
                        XV_Y,                 50,
                        WIN_ROWS,             40,
                        WIN_COLUMNS,          80,
                        TEXTSW_READ_ONLY,     TRUE,
                        TEXTSW_FILE_CONTENTS, NULL,
                                              NULL);

  my_canvas = xv_create(frame,                 CANVAS,
                        XV_X,                  0,
                        XV_Y,                  50,
                        XV_WIDTH,              30,
                        XV_HEIGHT,             350,
                        CANVAS_REPAINT_PROC,   canvas_repaint_proc,
                        CANVAS_X_PAINT_WINDOW, TRUE,
                        WIN_CMS,               my_cms,
                                                  NULL);

  my_sb = xv_get(my_textsw, TEXTSW_SCROLLBAR);

  if (!my_sb) {
    fprintf(stderr,"null h malakia ...\n");
    exit(-1);
  }

  xv_set(frame , FRAME_LABEL, " Help For FILE ", NULL);
  xv_set(my_textsw ,TEXTSW_FILE_CONTENTS , NULL , NULL);

  xv_main_loop(frame);
}

void q_help() {
  Frame frame;

  frame = xv_get(xv_get(quit_file_help, PANEL_PARENT_PANEL), XV_OWNER);

  PLAY_WITH_SOURCE_CODE = 0;
  SourceCodeActive = 0;

  xv_destroy_safe(frame);
}

void canvas_repaint_proc(canvas, paint_window, dpy, xwin, xrects)
Canvas        canvas;         /* unused */
Xv_Window     paint_window;   /* unused */
Display      *dpy;
Window        xwin;
Xv_xrectlist *xrects;         /* unused */
{
  GC  gc;
  int width, height;
  int i;

  gc = DefaultGC(dpy, DefaultScreen(dpy));
  xv_set(my_canvas,WIN_FOREGROUND_COLOR,CMS_CONTROL_COLORS+1,NULL);
  XClearWindow(dpy, xwin);
  width = (int)xv_get(paint_window, XV_WIDTH);
  height = (int)xv_get(paint_window, XV_HEIGHT);
  XDrawLine(dpy, xwin, gc, 0, 81, 30, 81);
}

/*************  danalis code START ****************************/

void Change_Contents(WhichFile)
char *WhichFile;{

  struct stat *buf;
  buf = (struct stat *)calloc(1,sizeof(struct stat));
  if( stat(WhichFile,buf) && ( errno == ENOENT || errno == ENOTDIR ) ){
/*
    fprintf(stderr,"\n#### %s: file does not exist\n\n",WhichFile);
*/
    Src_Not_Here = 1;
    return;
  }
  Src_Not_Here = 0;
  xv_set(my_textsw, TEXTSW_FILE_CONTENTS ,WhichFile, NULL);
}

void MarkLine(line, WhichFile)int line; char *WhichFile;{
  static int Start_From = 0, End_To = 25;

  if(Src_Not_Here)
    return;
  if( line >= Start_From && line <= End_To ){
    textsw_set_selection(my_textsw,
                         textsw_index_for_file_line(my_textsw,line),
                         textsw_index_for_file_line(my_textsw,line+1),
                         1 );
  }
  else{
    Start_From = line - 1;
    End_To = line + 24;
    textsw_normalize_view(my_textsw,textsw_index_for_file_line(my_textsw,line));
    fprintf(stderr,"Normalizing View to line: %d\n",line);
    textsw_set_selection(my_textsw,
                         textsw_index_for_file_line(my_textsw,line),
                         textsw_index_for_file_line(my_textsw,line+1),1);
  }
}
/*************  danalis code END   ****************************/
