#include <stdio.h>
#include <varargs.h>
#include <sys/time.h>
#include <sys/utsname.h>
#include "arguments.h"

#define TVTIME(tv)      ((tv).tv_sec + (tv).tv_usec / 1e6)

extern char     *anal_usage, *anal_version,
		*shade_bench_path, *shade_ego, *shade_version,
		*shade_argtrange();

extern  char    *ctime();
extern  int     analyze();
extern  long    time();
extern  void    exit(), initialize(), terminate();
extern  void    getcputime();
extern	void	PrintUsefulResults();
extern	void	init_Tlb();
extern	void	init_dtb_structures();
extern	void	init_information_arrays();
extern	char	*actions();
extern	char	*get_socket_connection();
extern	char	*accept_connection_and_use_socket();
extern	int	servershutdown();

extern	int	READ_COMMANDS_FROM_FILE;

FILE    *statsfp;
double	nina;

static double   usr, sys, real;
static int      t_flag,
		main_stats_analyze();
static void     main_stats_start(),
		main_stats_stop();

arguments	*split_command();

int     aargc;
char    **aargv;
int	pid; 

char		*abel_argv[20];
char		command_buffer[120];

FILE		*ffp;

extern	int	CONNECTION_IS_OK;	
extern	int	connection;

int
shade_main (argc, argv, envp)
int	  argc;
char *argv[], *envp[];
{
  int		ec, i, j, arg_i;
  char	 	*cmd = 0, *x;
  char		my_command[128];
  static	int	first_time = 0;
  int		count = 0;
  char		*temp_arg = 0;
  arguments	*splited_cmd = 0;

  pid = getpid();
	
  argc = shade_splitargs (argv, &aargv, &aargc);
/*  fprintf(stderr,"step 1: argc = %d \n",argc); */

  if (!statsfp)
    statsfp = stdout;

  init_information_arrays();

  strcpy(my_command , get_socket_connection());
  CONNECTION_IS_OK = 1;

  init_Tlb();
  initialize();
/*  fprintf(stderr,"step 2: After TLB initialization\n"); */

  main_stats_start();
/*  fprintf(stderr,"step 3: after main_stats_start\n"); */
		

  while(1){
    if (!READ_COMMANDS_FROM_FILE){
      if (!first_time){
        first_time = 1;
      }
      else{
        strcpy(my_command , actions(connection));
        CONNECTION_IS_OK = 1;
        initialize();
        init_dtb_structures();
      }
    }
    else{
      if (!first_time && READ_COMMANDS_FROM_FILE){
        first_time = 1;
        ffp = fopen("../shade/main/READ_COMMANDS","r");
        if (!ffp) {
          fprintf(stderr,"Program Execution Stop because ");
          fprintf(stderr,"it cannot open Command File\n");
          exit(-1);
        }
        if (fgets(command_buffer, 120, ffp)){
          CONNECTION_IS_OK = 1;
          strcpy(my_command, command_buffer);
        }
        else{
          READ_COMMANDS_FROM_FILE = 0;
          fclose(ffp);
          analyze(0);
          continue;
        }
      }
      else{
        if (READ_COMMANDS_FROM_FILE && first_time) {
          if (fgets(command_buffer, 120, ffp)){
            CONNECTION_IS_OK = 1;
            strcpy(my_command, command_buffer);
          }
          else{
            READ_COMMANDS_FROM_FILE = 0;
            analyze(0);
            fclose(ffp);
            continue;
          }
        }
      }
    }

/*    fprintf(stderr,"shade main: command is %s \n",my_command); */
    if (!strcmp(my_command,"quit")){
      READ_COMMANDS_FROM_FILE = 0;
      analyze(0);
      if(ffp != NULL) /**** if() is added by danalis ****/
        fclose(ffp);
      break;
    }

    temp_arg = (char *)malloc(100*sizeof(char));
    strcpy(temp_arg,"cachesim5");
    
    abel_argv[0] = temp_arg;
    
    splited_cmd = split_command(my_command);
    strcpy(my_command,splited_cmd->command);

    arg_i = 1;

    while(1){
      if (!strcmp(splited_cmd->argument,""))
        break;
      splited_cmd = split_command(splited_cmd->argument);
      
      temp_arg = (char *)malloc(sizeof(char)*(strlen(splited_cmd->argument)+1));
      strcpy(temp_arg,splited_cmd->command);
      abel_argv[arg_i] = temp_arg;
      arg_i++;
    }

    abel_argv[arg_i] = NULL;

    count = 0;
    while (abel_argv[count]){
/*      fprintf(stderr,"argv[%d] = %s \n",count,abel_argv[count]);	*/
      count++;
    }

    if (shade_loadp(my_command,abel_argv,envp) < 0){
/*      fprintf(stderr,"step 4: first point ...\n"); */
      /****** exit(0); ******/
      continue;
    }
    else{
/*      fprintf(stderr,"step 5: after shade_loadp\n"); */
      main_stats_analyze (aargc, my_command, envp, (char **) 0);
/*      fprintf(stderr,"step 6: after main_stats_analyze\n");         */
    }
		
    PrintUsefulResults();

    /*****************************************
    main_stats_stop();
    terminate();
    close(connection);
    fprintf(stderr,"CONNECTION CLOSED !!!\n");
    servershutdown();
    *****************************************/

  }

  /*****************************************
  if (pid == getpid()){
  }
  *****************************************/

}

usage (va_alist)
va_dcl
{
  char	*fmt;
  va_list	ap;

  va_start (ap);
  fmt = va_arg (ap, char *);

  if(fmt && *fmt){
    fprintf (stderr, "%s: ", shade_ego);
    vfprintf (stderr, fmt, ap);
    fprintf (stderr, "\n\n");
  }
  va_end (ap);

  fprintf (stderr, "usage: %s [-U] [-V] [-o outfile] [+/-t[from],[to]] ",
           shade_ego);
  if (anal_usage && *anal_usage)
    fprintf (stderr, "\\\n\t%s ", anal_usage);
  fprintf (stderr, "\\\n\t[-c \"command\" | -- bench benchargs]\n");

  exit (1);
}


static void
getrealtime (real)
double	*real;
{
	struct timeval	tv;
	struct timezone	tz;

	tz.tz_dsttime = DST_NONE;
	tz.tz_minuteswest = 0;

	(void) gettimeofday (&tv, &tz);

	*real = TVTIME (tv) - *real;
}


static void
main_stats_start()
{
	long    	start;
	struct utsname	u;


	if (statsfp == 0)
		return;

/*
	fprintf (statsfp, "Analyzer: %s\n", shade_ego);
	fprintf (statsfp, "Version: %s (shade version: %s)\n",
	    anal_version, shade_version);
*/

	if (-1 != uname (&u))
        ;
/*
		fprintf (statsfp, "Uname: %s %s %s %s %s\n",
		    u.nodename, u.machine, u.sysname, u.release, u.version);
*/

	(void) time (&start);
	getrealtime (&real);
	getcputime (&usr, &sys);

/*
	fprintf (statsfp, "Start: %s", ctime (&start));
*/
	fflush (statsfp);
}


static int
main_stats_analyze (argc, argv, envp, iov)
int	argc;
char	**argv, **envp, **iov;
{
  double	lastnina = nina;
  int	i;

  /* BUG: if t_flag, shouldn't change application program */

  if (statsfp){
/*
    fprintf (statsfp, "Application: %s", shade_bench_path);
*/
    for (i = 1; i < argc; i++){
      fprintf (statsfp, " %s", argv[i]);
    }
    if (iov){
      for (i = 0; iov[i]; i += 2){
        fprintf (statsfp, " %s", iov[i]);
        if (iov[i+1])
          fprintf (statsfp, " %s", iov[i+1]);
      }
    }
    fprintf (statsfp, "\n");
    fflush (statsfp);
  }

  i = analyze(1);

  if (statsfp){
    if (nina > lastnina){
      fprintf (statsfp, "Application Instructions: %.0f\n", nina - lastnina);
    }
    fflush (statsfp);
  }

  return i;
}


static void
main_stats_stop()
{
	long	stop;

	if (statsfp == 0)
		return;

	(void) time (&stop);
	getcputime (&usr, &sys);
	getrealtime (&real);

	fprintf (statsfp, "Stop: %s", ctime (&stop));
	if (nina > 0)
		fprintf (statsfp, "Instructions: %.0f\n", nina);
	fprintf (statsfp, "Time: %.3f usr  %.3f sys  %.3f real  %.3f%%\n",
	    usr, sys, real,
	    real > 0 ? 100. * (usr + sys) / real : 100.);
	if (usr + sys > 0 && nina > 0)
		fprintf (statsfp, "Speed: %.3f KIPS\n", 
		    nina / (usr + sys) / 1000.);
}

arguments *
split_command(cmd)
char    *cmd;
{
        arguments       *tmp;
        char            *args;
        int             i,count;

        tmp = (arguments *)malloc(sizeof(arguments));
        tmp->command = (char *)malloc(sizeof(char)*strlen(cmd));
        tmp->argument = (char *)malloc(sizeof(char)*strlen(cmd));

        args = (char *)malloc(sizeof(char)*strlen(cmd));

   /*     printf("split_args: before sscanf, cmd is: %s \n",cmd); */
		i = 0; 
		while (cmd[i] != '\0' && cmd[i] != '\t' && cmd[i] != ' ')
		{
			tmp->command[i] = cmd[i];
			i++;
		}	
		if (cmd[i] == '\0')
		{
			tmp->command[i] = '\0';
			strcpy(tmp->argument,"");
		}
		else
		{
			int	k;
			tmp->command[i] = '\0';
			i++;
			k = 0;
			while (cmd[i] != '\0')
				tmp->argument[k++] = cmd[i++];
			tmp->argument[k] = '\0';
		}
	
	/*
        sscanf(cmd, "%s %s\n",tmp->command,tmp->argument);

		
        i = 0;
        while (tmp->command[i++] != '\0')
                ;

        count = 0;
        while (cmd[i] != '\0')
        {
                args[count] = cmd[i];
                count++;
                i++;
        }
        args[count] = '\0';
        strcpy(tmp->argument,args);

        printf("split_args: tmp->command iss %s \n",tmp->command);
        printf("split_args: tmp->argument is %s \n",tmp->argument);

	*/
        return tmp;
}
